/*
Program: bowling-std-qsort.c (Report comments/bugs to chikh@yuntech.edu.tw)
Function: ŪOֲyɪ̪mWPnɮסAA̤ƪCHCتqsort()
		@ƧǨܱƦWT
*/

#include <stdio.h>
#include <stdlib.h>

typedef struct game {  /* wqgameƵc */ 
		char name[10];
		int  score;
} player; 

player *readFile(int *totalRec)	
{
	int  i, count = 0;
	FILE *fptr;
	char line[80];
	player *game;
	
	if ((fptr=fopen("bowling-scores.txt","r"))==NULL) {
		perror("bowling-scores.txt");
		exit(1);
	}
	while (fgets(line,80,fptr) != NULL) count++;
	game = malloc(count*sizeof(player));
	rewind(fptr); //fseek(fptr,0,SEEK_SET);
	for (i = 0; i < count; i++) 
		fscanf(fptr,"%s %d",game[i].name,&game[i].score);
	fclose(fptr);	
	
	*totalRec = count;
	
	return game;
}

int ascend(const void *a, const void *b) /* WҦ */ 
{
	player *x = (player *)a, *y = (player *)b;
	return x->score - y->score;
}

int descend(const void *a, const void *b) /* Ҧ */ 
{
	player *x = (player *)a, *y = (player *)b;
	return y->score - x->score;
}

/*
void bubbleSort(player *bowling, int totalRec)
{
	int i, j;
	player temp;
	
	for (i = 0; i < totalRec-1; i++) 
    	for (j = 0; j < totalRec-i-1; j++)
     		if (bowling[j].score < bowling[j+1].score) {
				temp = bowling[j];      
				bowling[j] = bowling[j+1];
				bowling[j+1] = temp;
	   		}
}
*/

void showData(player *bowling, int totalRec)
{
	int i;
	
	printf("OֲyZƦ\n--------------------\n");
    for (i = 0; i < totalRec; i++) 
		printf("%2d. %s\t%d\n",i+1,bowling[i].name,bowling[i].score);
	printf("====================\n");
}

int main()
{
    int    totalRec;
    player *bowling;
    
    bowling = readFile(&totalRec);
    qsort(bowling,totalRec,sizeof(bowling[0]),descend); //qsort(bowling,totalRec,sizeof(bowling[0]),ascend);  
    showData(bowling,totalRec);
    			
    return 0;
}
