/*
Program: quicksort''.c (Report bugs/comments to chikh@yuntech.edu.tw)
Function: ۸quickSort.cAdҵ{ѥt@اֳtƧǪk@覡F 
		  J 39 11 48 5 77 18 70 25 55 33  
*/

#include <stdio.h>

void swap(int *a, int *b) 
{ 
    int temp = *a; 
    *a = *b; 
    *b = temp; 
} 

int partition(int data[], int low, int high) 
{ 
	int i = low-1, j; 
    int pivot = data[high]; /* ϥγ̥@ */ 
  
    for (j = low; j <= high-1; j++) { /* data[]}CpivotphEApivotjk䶰 */
        if (data[j] < pivot) { 
            i++; 
            swap(&data[i],&data[j]); 
        } 
    } /* oforj{XuA޿TAi޵oƷhʪ欰AuƪŶ */
    swap(&data[i+1],&data[high]); 
    
    return (i+1); 
} 
  
void quickSort(int data[], int low, int high, int size) 
{
	int i, pivotIndex;
	
    if (low < high) { 
        pivotIndex = partition(data,low,high); 
        /* -------------------- */
        printf("Processing: ");
        for (i = 0; i < size; i++) printf("%3d  ",data[i]);
        printf("\n");
        /* -------------------- */
        quickSort(data,low,pivotIndex-1,size); 
        quickSort(data,pivotIndex+1,high,size); 
    }
} 

void printDashLine()
{
    int i;
    
    for (i = 0; i < 62; i++) printf("-");
    printf("\n");
}

int main()
{
	char ch;
	int data[20];
    int size = 0, i;
    
    /*
    printf("\nпJ(J0ܵ): ");
    do {
        scanf("%d",&data[size]);
    } while (data[size++] != 0);
    size--;	
	*/ 
    
    printf("\nпJ: "); /* J0ܵ */
    do  // http://bit.ly/2GUtU47
    	scanf("%d%c",&data[size++],&ch);
  	while (ch != '\n');
    
    printDashLine();	/* CLju */
    quickSort(data,0,size-1,size);
    printDashLine();	/* CLju */
    
    printf("ѤpܤjƧǫ᪺: ");
    for (i = 0; i < size; i++) printf("%d  ",data[i]); /* ܱƧǵG */
    printf("\n");

	return 0;
}
